"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var getFonts_1 = require("./getFonts");
var transform_1 = require("./transform");
var args = require('yargs-parser')(process.argv.slice(2));
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var font_1, join_1;
        return __generator(this, function (_a) {
            if (args.help) {
                help();
                return [2 /*return*/, process.exit(0)];
            }
            else if (args.list) {
                list();
                return [2 /*return*/, process.exit(0)];
            }
            else if (args.font) {
                font_1 = getFonts_1.getFonts()[args.font];
                if (!font_1) {
                    console.error('Cannot find font ' + args.font + '.\nThese are the ones available: ');
                    list();
                    return [2 /*return*/, process.exit(1)];
                }
                join_1 = -1;
                if (args.join) {
                    join_1 = parseInt(args.join);
                    if (!join_1 || join_1 === 0 || join_1 < 0 || join_1 === NaN) {
                        console.error('Invalid Join value, resulted on number ' + join_1);
                        process.exit(1);
                    }
                }
                if (args.input) {
                    processInput(font_1, join_1, args.input);
                    return [2 /*return*/, process.exit(0)];
                }
                else {
                    process.stdin.resume();
                    process.stdin.setEncoding('utf8');
                    process.stdin.on('data', function (chunk) {
                        processInput(font_1, join_1, chunk);
                    });
                    process.stdin.on('end', function () {
                        return process.exit(0);
                    });
                }
            }
            else {
                console.error('Invalid call');
                help();
                return [2 /*return*/, process.exit(1)];
            }
            return [2 /*return*/];
        });
    });
}
exports.main = main;
function processInput(font, join, input) {
    var result = transform_1.transform(input, font, join);
    if (args.outputFile) {
        fs_1.appendFileSync(args.outputFile, result);
    }
    else {
        process.stdout.write(result);
    }
}
function list() {
    var s = 'HELLO world 01234567689';
    console.log(Object.values(getFonts_1.getFonts())
        .map(function (f) { return " * " + transform_1.transform(s, f, -1) + " : " + f.name + " (" + f.description + ")"; })
        .join('\n'));
}
function help() {
    console.log("\nUsage examples: \n\n  unicode-fonts --list\n  unicode-fonts --font scriptItalic --input \"My name is Sebastian Gurin\"\n  cat package.json | unicode-fonts --font boldItalic\n  cat package.json | unicode-fonts --font circled --join \"0x3000\" --outputFile package-boldItalic.json\n\n  --list: list supported fonts\n  --font (mandatory) a supported font name to format input\n  --input (optional) a string to format. If not provided it will read from stdin\n  --join (optional) if given it will join characters with that character. Must be \n    a single character in hexadecimal format, ej: \"0x2009\". See README for more \n    details. If not provided, there will be no join\n  --outputFile if provided it will write the output to given file. If not provided it will write to stdout.\n");
}
//# sourceMappingURL=cli.js.map